    #include<stdio.h>
    #include<stdlib.h>
    #include<time.h>
    #include <string.h>
    #include <unistd.h>
    #include <fcntl.h>
    #include <errno.h>
    #include <termios.h>

    unsigned char pacote[16];
    unsigned char recebe[16];
    unsigned char entrada;
    char comando=0;
    int flagMenu=0;
    int flagRx=0;
    int fd;
    int k=0;
    int b = 0;
    int contador=0;
    int exec=0;
    int tentativa = 0;
    union checksum {
	
	unsigned short int soma;
	unsigned short int soma2;
	unsigned char checksumm[2];
	
	
    };

    void geraPacote();
    void controleLed(int select);
    void geraSoma();
    void checaSoma();
    void mostraPacote();
    int transmiteUART();
    int kbhit(void);
    int verificaRx();
    
     #define BAUDRATE B9600	
      #define MODEMDEVICE "/dev/ttyS0"
      #define _POSIX_SOURCE 1 /* POSIX compliant source */
      #define FALSE 0
      #define TRUE 1


    void main(){

	struct termios oldtio,newtio;
	tcgetattr(fd,&oldtio); /* save current port settings */
	fd = open("/dev/ttyAMA0", O_RDWR | O_NOCTTY | O_NONBLOCK); //abre a porta serial
	//fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NONBLOCK); //abre a porta serial
	if(fd<1){
	    printf("comunicacao UART nao disponivel\n%");
	    exit(1);
	
	}
	printf("\n fd eh: %d",fd);
        tcgetattr(fd,&oldtio); /* save current port settings */
        
        //bzero(&newtio, sizeof(newtio));
        newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
        newtio.c_iflag = IGNPAR| IXON | IXOFF;
        newtio.c_oflag = 0;
        
        /* set input mode (non-canonical, no echo,...) */
        newtio.c_lflag = 0;
         
        newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
      //  newtio.c_cc[VMIN]     = 1;   /* blocking read until 5 chars received */
        
        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&newtio);
	
	
	while(comando != 'q'){
	    
	    if(kbhit()){
		comando = getchar();
	    }
	    
	    if(flagMenu == 0){
		printf("Digite a opcao desejada: \n a - Acende/Apaga Led 1\n b - Acende/Apaga Led 2\n c - Acende/Apaga Led 3\n");
		
		flagMenu=1;
	    }
						    
	    if(comando == 'a'){
		b = 1;
		printf("Enviando comando para acender/apagar Led 1\n");
		controleLed(b);
		mostraPacote();
		geraSoma();
		transmiteUART();
		comando = 0;
		//flagMenu=0;
	    }
	    
	    if(comando == 'b'){
		b = 2;
		printf("Enviando comando para acender/apagar Led 2\n");
		controleLed(b);
		mostraPacote();
		geraSoma();
		transmiteUART();
		comando = 0;
		//flagMenu=0;
	    }
	    
		if(comando == 'c'){
		b = 3;
		printf("Enviando comando para acender/apagar Led 2\n");
		controleLed(b);
		mostraPacote();
		geraSoma();
		transmiteUART();
		comando = 0;
		//flagMenu=0;
	    }
	 verificaRx();
	}           
    
    }

    
    
void mostraPacote(){
    int i;
    for(i = 0; i<16 ; i++ ){
	printf("%c",pacote[i]);
    }
    printf("\n\n\n");
}

void geraPacote(){
    pacote[0] = '#';
    int i=1;
    
    srand( (unsigned)time(NULL) );      //zerar a semente
    
    for(i=1;i<16;i++){     
	pacote[i] = 65 + rand()%126;    //ajuste da função rand para gerar char ASCII       
    }
}

void controleLed(int b){
    int a = b;				

    geraPacote();
    pacote[1] = 'L';
    pacote[2] = 'E';
    pacote[3] = 'D';


    switch(a){

    case 1:
    pacote[4] = '1';
    break;
    
    case 2:
    pacote[4] = '2';
    break;
    
    case 3:
    pacote[4] = '3';
    break;
    
	default:
	printf("Não tem esse led fera!\n");
    
}           
    }

    void geraSoma(){
	int j=0;
	union checksum chk;
	chk.soma = 0;
	for(j=0; j<=13; j++){
	    chk.soma += pacote[j];
	}
	
	pacote[14] = chk.checksumm[0];
	pacote[15] = chk.checksumm[1];
	//pacote[15] = 0; //testar se buga
	printf("A soma total eh: %d\n ",chk.soma);
	printf("A soma 1  eh: %d\n ",pacote[14]);
	printf("A soma 2 eh: %d\n\n ",pacote[15]);		
	
    }
    
    int transmiteUART(){
	int n=0;
	if(flagRx==0){		//só vai transmitir se estiver dado certo a ultima, ou for a primeira vez			
			    
	    if (fd == -1) {			
		perror("Não deu pra abrir a porta serial /dev/ttyAMA0 - \n ");
		return(-1);			
	    }
	    
	    fcntl(fd, F_SETFL, 0);
	    
	    n = write(fd,&pacote[0],16);
	    flagRx = 1; //indica que foi feita uma transmissao e que é esperada uma resposta
	    
	    if (n < 0) {			
		perror("Falha na escrita \n");
		return -1;			
	    }           
	    printf("transmiti\n\n");
	}
	//verificaRx();
	
	return 0;
    }
    
    int kbhit(void){
	
	struct termios oldt, newt;
	int ch;
	int oldf;
	
	tcgetattr(STDIN_FILENO, &oldt);
	newt = oldt;
	newt.c_lflag &= ~(ICANON | ECHO);
	tcsetattr(STDIN_FILENO, TCSANOW, &newt);
	oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
	fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
	 
	ch = getchar();
	
	tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
	fcntl(STDIN_FILENO, F_SETFL, oldf);
	 
	if(ch != EOF){
	    ungetc(ch, stdin);
	    return 1;
	}
	 
	return 0;
}
    int verificaRx(){ //função é chamada a todo momento porém só executa se é esperada uma resposta do cliente
	int n=0;
	

	if(flagRx==1){	//quando flagRX for 1, 
	    //printf("a flagRx é: %d\n", contador);	
	    contador++;
	    //entrada = 0;
	    n = read(fd,&entrada,1);
	    //usleep(10000);
	    if(n ){				
		recebe[0] = recebe[1];
		recebe[1] = recebe[2];
		recebe[2] = recebe[3];
		recebe[3] = recebe[4];
		recebe[4] = recebe[5];
		recebe[5] = recebe[6];
		recebe[6] = recebe[7];
		recebe[7] = recebe[8];
		recebe[8] = recebe[9];
		recebe[9] = recebe[10];
		recebe[10] = recebe[11];
		recebe[11] = recebe[12];
		recebe[12] = recebe[13];
		recebe[13] = recebe[14];
		recebe[14] = recebe[15];
		recebe[15] = entrada;
		//entrada = 0;
		k++;
	    }
	    
	    if(recebe[0] == '#'){ //se o primeiro byte for o # ...
		printf("to exec...");
		//recebe[15] = entrada;
		checaSoma();	//verifica se esta correto o pacote
		recebe[0] = 0;	//executa somente 1x
		
		printf(	"fui chamado %d vezes",k);
		
	    }
	     if(contador>=50000){
		exec++;
		contador = 0;
		printf(	"estourou %d vezes\n",exec);
	     }
	     if(exec>=3){
		 flagRx=0;
		 exec=0;
		 printf("Retransmitindo último pacote...\n");
		 controleLed(b);
		 mostraPacote();
		 geraSoma();
		 printf("Retransmitindo pacote\n");
		 transmiteUART();	
		 tentativa++;
	     }
	     if(tentativa>=3){
		 printf("Impossível conectar ao cliente, verifique as conexões\n FLW VLW\n");
		 comando='q';
	     }
	}
return 0;
    }
    
    void checaSoma(){
	int i=0;
	int j =0;
	
	union checksum checaRx;
	
	checaRx.soma = 0;
	checaRx.checksumm[0] = 0;
	checaRx.checksumm[1] = 0;
	printf("Arduino retornou o pacote: ");
	recebe[15] = entrada;
	for(j = 0; j<16 ; j++ ){
	    printf("%c",recebe[j]);
        }
        printf("\n\n\n");
	
	for(i=0; i<14; i++){
	    checaRx.soma += recebe[i];
	}
	
	if(recebe[14] == checaRx.checksumm[0] && recebe[15] == checaRx.checksumm[1]){ // se bater o checksum
	    printf("Recepcao Correta\n");
	    
	    if(recebe[1]=='E' && recebe[2]=='R' && recebe[3]=='R' && recebe[4]=='O'){
		printf("Erro, o cliente não pode executar o comando enviado!\n");
	    }
	    
	    if(recebe[1]==pacote[1] && recebe[2]==pacote[2] && recebe[3]==pacote[3] && recebe[4]==pacote[4] && recebe[5]=='O' && recebe[6]=='K'){
		printf("Comando enviado foi executado com sucesso!\n");
		printf("Deu bom\n");
	    printf("check recebido é: %d e %d e o check calculado é %d e %d\n\n", recebe[14], recebe[15], checaRx.checksumm[0], checaRx.checksumm[1]);
		flagRx = 0;
		flagMenu=0;
	    }
	    else{
		printf("Deu ruim, nao veio erro nem OK\n");
		flagRx = 0;
		controleLed(b);
		mostraPacote();
		geraSoma();
		printf("Retransmitindo pacote\n");
		transmiteUART();				
	    }
	}
	else{
	    printf("Deu ruim, não bateu o checksum do pacote recebido\n");
	    printf("check recebido é: %d e %d e o check calculado é %d e %d\n\n", recebe[14], recebe[15], checaRx.checksumm[0], checaRx.checksumm[1]);
	}
    }